package org.jeecg.modules.fbsAbnormalWorkingHours.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursDescribe;
import org.jeecg.modules.fbsAbnormalWorkingHours.service.IFbsAbnormalWorkingHoursDescribeService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;

 /**
 * @Title: Controller
 * @Description: 异常工时描述
 * @author： jeecg-boot
 * @date：   2020-10-14
 * @version： V1.0
 */
@RestController
@RequestMapping("/fbsAbnormalWorkingHours/fbsAbnormalWorkingHoursDescribe")
@Slf4j
public class FbsAbnormalWorkingHoursDescribeController {
	@Autowired
	private IFbsAbnormalWorkingHoursDescribeService fbsAbnormalWorkingHoursDescribeService;
	
	/**
	  * 分页列表查询
	 * @param fbsAbnormalWorkingHoursDescribe
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@GetMapping(value = "/list")
	public Result<IPage<FbsAbnormalWorkingHoursDescribe>> queryPageList(FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe,
									  @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
									  @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
									  HttpServletRequest req) {
		Result<IPage<FbsAbnormalWorkingHoursDescribe>> result = new Result<IPage<FbsAbnormalWorkingHoursDescribe>>();
		QueryWrapper<FbsAbnormalWorkingHoursDescribe> queryWrapper = QueryGenerator.initQueryWrapper(fbsAbnormalWorkingHoursDescribe, req.getParameterMap());
		queryWrapper.lambda().eq(FbsAbnormalWorkingHoursDescribe::getDelFlag,"0");
		queryWrapper.lambda().orderByAsc(FbsAbnormalWorkingHoursDescribe::getSort);
		Page<FbsAbnormalWorkingHoursDescribe> page = new Page<FbsAbnormalWorkingHoursDescribe>(pageNo, pageSize);
		IPage<FbsAbnormalWorkingHoursDescribe> pageList = fbsAbnormalWorkingHoursDescribeService.page(page, queryWrapper);
		result.setSuccess(true);
		result.setResult(pageList);
		return result;
	}
	
	/**
	  *   添加
	 * @param fbsAbnormalWorkingHoursDescribe
	 * @return
	 */
	@PostMapping(value = "/add")
	public Result<FbsAbnormalWorkingHoursDescribe> add(@RequestBody FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe) {
		Result<FbsAbnormalWorkingHoursDescribe> result = new Result<FbsAbnormalWorkingHoursDescribe>();
		try {
			fbsAbnormalWorkingHoursDescribeService.save(fbsAbnormalWorkingHoursDescribe);
			result.success("添加成功！");
		} catch (Exception e) {
			e.printStackTrace();
			log.info(e.getMessage());
			result.error500("操作失败");
		}
		return result;
	}
	
	/**
	  *  编辑
	 * @param fbsAbnormalWorkingHoursDescribe
	 * @return
	 */
	@PutMapping(value = "/edit")
	public Result<FbsAbnormalWorkingHoursDescribe> edit(@RequestBody FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe) {
		Result<FbsAbnormalWorkingHoursDescribe> result = new Result<FbsAbnormalWorkingHoursDescribe>();
		FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribeEntity = fbsAbnormalWorkingHoursDescribeService.getById(fbsAbnormalWorkingHoursDescribe.getId());
		if(fbsAbnormalWorkingHoursDescribeEntity==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsAbnormalWorkingHoursDescribeService.updateById(fbsAbnormalWorkingHoursDescribe);
			//TODO 返回false说明什么？
			if(ok) {
				result.success("修改成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *   通过id删除
	 * @param id
	 * @return
	 */
	@DeleteMapping(value = "/delete")
	public Result<FbsAbnormalWorkingHoursDescribe> delete(@RequestParam(name="id",required=true) String id) {
		Result<FbsAbnormalWorkingHoursDescribe> result = new Result<FbsAbnormalWorkingHoursDescribe>();
		FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe = fbsAbnormalWorkingHoursDescribeService.getById(id);
		if(fbsAbnormalWorkingHoursDescribe==null) {
			result.error500("未找到对应实体");
		}else {
			boolean ok = fbsAbnormalWorkingHoursDescribeService.removeById(id);
			if(ok) {
				result.success("删除成功!");
			}
		}
		
		return result;
	}
	
	/**
	  *  批量删除
	 * @param ids
	 * @return
	 */
	@DeleteMapping(value = "/deleteBatch")
	public Result<FbsAbnormalWorkingHoursDescribe> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		Result<FbsAbnormalWorkingHoursDescribe> result = new Result<FbsAbnormalWorkingHoursDescribe>();
		if(ids==null || "".equals(ids.trim())) {
			result.error500("参数不识别！");
		}else {
			this.fbsAbnormalWorkingHoursDescribeService.removeByIds(Arrays.asList(ids.split(",")));
			result.success("删除成功!");
		}
		return result;
	}
	
	/**
	  * 通过id查询
	 * @param id
	 * @return
	 */
	@GetMapping(value = "/queryById")
	public Result<FbsAbnormalWorkingHoursDescribe> queryById(@RequestParam(name="id",required=true) String id) {
		Result<FbsAbnormalWorkingHoursDescribe> result = new Result<FbsAbnormalWorkingHoursDescribe>();
		FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe = fbsAbnormalWorkingHoursDescribeService.getById(id);
		if(fbsAbnormalWorkingHoursDescribe==null) {
			result.error500("未找到对应实体");
		}else {
			result.setResult(fbsAbnormalWorkingHoursDescribe);
			result.setSuccess(true);
		}
		return result;
	}

  /**
      * 导出excel
   *
   * @param request
   * @param response
   */
  @RequestMapping(value = "/exportXls")
  public ModelAndView exportXls(HttpServletRequest request, HttpServletResponse response) {
      // Step.1 组装查询条件
      QueryWrapper<FbsAbnormalWorkingHoursDescribe> queryWrapper = null;
      try {
          String paramsStr = request.getParameter("paramsStr");
          if (oConvertUtils.isNotEmpty(paramsStr)) {
              String deString = URLDecoder.decode(paramsStr, "UTF-8");
              FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe = JSON.parseObject(deString, FbsAbnormalWorkingHoursDescribe.class);
              queryWrapper = QueryGenerator.initQueryWrapper(fbsAbnormalWorkingHoursDescribe, request.getParameterMap());
          }
      } catch (UnsupportedEncodingException e) {
          e.printStackTrace();
      }

      //Step.2 AutoPoi 导出Excel
      ModelAndView mv = new ModelAndView(new JeecgEntityExcelView());
      List<FbsAbnormalWorkingHoursDescribe> pageList = fbsAbnormalWorkingHoursDescribeService.list(queryWrapper);
      //导出文件名称
      mv.addObject(NormalExcelConstants.FILE_NAME, "异常工时描述列表");
      mv.addObject(NormalExcelConstants.CLASS, FbsAbnormalWorkingHoursDescribe.class);
      mv.addObject(NormalExcelConstants.PARAMS, new ExportParams("异常工时描述列表数据", "导出人:Jeecg", "导出信息"));
      mv.addObject(NormalExcelConstants.DATA_LIST, pageList);
      return mv;
  }

  /**
      * 通过excel导入数据
   *
   * @param request
   * @param response
   * @return
   */
  @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
  public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
      MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
      Map<String, MultipartFile> fileMap = multipartRequest.getFileMap();
      for (Map.Entry<String, MultipartFile> entity : fileMap.entrySet()) {
          MultipartFile file = entity.getValue();// 获取上传文件对象
          ImportParams params = new ImportParams();
          params.setTitleRows(2);
          params.setHeadRows(1);
          params.setNeedSave(true);
          try {
              List<FbsAbnormalWorkingHoursDescribe> listFbsAbnormalWorkingHoursDescribes = ExcelImportUtil.importExcel(file.getInputStream(), FbsAbnormalWorkingHoursDescribe.class, params);
              for (FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribeExcel : listFbsAbnormalWorkingHoursDescribes) {
                  fbsAbnormalWorkingHoursDescribeService.save(fbsAbnormalWorkingHoursDescribeExcel);
              }
              return Result.ok("文件导入成功！数据行数：" + listFbsAbnormalWorkingHoursDescribes.size());
          } catch (Exception e) {
              log.error(e.getMessage());
              return Result.error("文件导入失败！");
          } finally {
              try {
                  file.getInputStream().close();
              } catch (IOException e) {
                  e.printStackTrace();
              }
          }
      }
      return Result.ok("文件导入失败！");
  }

  /**
  * @Author chenchuang
  * @Description //TODO 制造看板：月制程质量异常
  * @Date 2020/10/28 15:37
  * @Param []
  * @return org.jeecg.common.api.vo.Result<java.util.Map<java.lang.String,java.lang.Object>>
  */
  @GetMapping(value = "/getMonthExceptionByCategory")
	public Result<Map<String,Object>> getMonthExceptionByCategory(){
		Result<Map<String,Object>> result=new Result<>();
		try {
			Map<String,Object> map=fbsAbnormalWorkingHoursDescribeService.getMonthExceptionByCategory();
			result.setResult(map);
			result.success("操作成功");
		} catch (Exception e) {
			e.printStackTrace();
			result.error500("操作失败："+e.getMessage());
		}
		return result;
	}

	/**
	* @Author chenchuang
	* @Description //TODO 明细导出数据
	* @Date 2020/11/18 16:13
	* @Param [fbsAbnormalWorkingHoursDescribe]
	* @return org.jeecg.common.api.vo.Result<java.util.List<org.jeecg.modules.fbsAbnormalWorkingHours.entity.FbsAbnormalWorkingHoursDescribe>>
	*/
	@GetMapping(value = "/getListAndMain")
	public Result<List<FbsAbnormalWorkingHoursDescribe>> getListAndMain(FbsAbnormalWorkingHoursDescribe fbsAbnormalWorkingHoursDescribe){
		Result<List<FbsAbnormalWorkingHoursDescribe>> result=new Result<>();
		try {
			List<FbsAbnormalWorkingHoursDescribe> fbsAbnormalWorkingHoursDescribeList=fbsAbnormalWorkingHoursDescribeService.getListAndMain(fbsAbnormalWorkingHoursDescribe);
			result.setResult(fbsAbnormalWorkingHoursDescribeList);
			result.success("操作成功");
		} catch (Exception e) {
			e.printStackTrace();
			result.error500("操作失败："+e.getMessage());
		}
		return result;
	}


	 @GetMapping(value = "/getMonthExceptionByCategoryTwo")
	public Result<List<Map<String,Object>>> getMonthExceptionByCategoryTwo(){
		Result<List<Map<String,Object>>> result=new Result<>();
		try {

			result.setResult(fbsAbnormalWorkingHoursDescribeService.getMonthExceptionByCategoryTwo());
			result.success("操作成功");
		} catch (Exception e) {
			e.printStackTrace();
			result.error500("操作失败："+e.getMessage());
		}
		return result;
	}
}
